/*客户端生成唯一标识符uuid*/
function getUuid(len, radix) {
  var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
  var uuid = [], i;
  radix = radix || chars.length;
  if (len) {
    // Compact form
    for (i = 0; i < len; i++) uuid[i] = chars[0 | Math.random()*radix];
  } else {
    // rfc4122, version 4 form
    var r;
    // rfc4122 requires these characters
    uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
    uuid[14] = '4';
    // Fill in random data. At i==19 set the high bits of clock sequence as
    // per rfc4122, sec. 4.1.5
    for (i = 0; i < 36; i++) {
      if (!uuid[i]) {
      r = 0 | Math.random()*16;
      uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
      }
    }
  }
  return uuid.join('');
}
function getOpenId() {
    var d = new Date().getTime();
    if (window.performance && typeof window.performance.now === "function") {
        d += performance.now(); //use high-precision timer if available
    }
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
    });
    return uuid;
}
/*检查storage是否过期*/
function getValue(key){
    var obj=$api.getStorage(key);
    if(!obj){return false}
    if(key='access_token'){
        if(new Date().getTime()-obj.deadline>0){
            $api.rmStorage(key);
            return false
          }else{
            return obj.value
          }
    }

  return obj.value

  // else{
  //   // if(new Date().getTime()-obj.deadline>0){
  //   //   $api.rmStorage(key);
  //   //   return false
  //   // }else{
  //   //   return obj.value
  //   // }
  //   retrun obj.value
  // }
}
/*首页返回键退出app*/
function exitApp() {
    api.addEventListener({
        name: 'keyback'
    }, function(ret, err) {
        api.toast({
            msg: '再按一次返回键退出' + api.appName,
            duration: 2000,
            location: 'bottom'
        });
        api.addEventListener({
            name: 'keyback'
        }, function(ret, err) {
            api.closeWidget({
                id: 'A6098433266579', //这里改成自己的应用ID
                retData: { name: 'closeWidget' },
                silent: true
            });
        });
        setTimeout(function() {
            exitApp();
        }, 3000)
    });
}
/*将登陆token相关存到本地*/
function setValue(key,value,time){
  var t=3600*24*1000*100;/*默认过期时间*/
  if(time){
    t=time*1000
  }else{

  }
  var obj={value:value,deadline:new Date().getTime()+t}
  $api.setStorage(key, obj);
}
/*上拉加载*/
function pullUpLoading(callback){
    api.addEventListener({
        name: 'scrolltobottom',
        extra:{
            threshold: 20  /*设置距离底部多少距离时触发，默认值为0，数字类型*/
        }
    }, function(ret, err){
        callback()
    });
}
var strategy = {
    isNotEmpty: function(value,errorMsg) {
        if(value === '') {
            return errorMsg;
        }
    },
    // 限制最小长度
    minLength: function(value,length,errorMsg) {
        if(value.length < length) {
            return errorMsg;
        }
    },
    // 手机号码格式
    mobileFormat: function(value,errorMsg) {
        if(!/(^1[3|5|8][0-9]{9}$)/.test(value)) {
            return errorMsg;
        }
    }
};
/*打开新的窗口*/
function openWin(name,data){
    var delay = 0;
    if(api.systemType != 'ios'){
        delay = 300;
    }
    console.log(JSON.stringify(data))
    api.openWin({
        name: ''+name,
        url: api.wgtRootDir+'/html/'+name+'.html',
        bounces:false,
        delay: delay,
        reload: true,
        pageParam:data,
        slidBackEnabled:true,
        vScrollBarEnabled:false
    });
}
/*原生模块弹窗*/
function dialogBox_alert(params,callback){
    /**
     * 使用dialogBox模块封装的alert方法
     * 参数:
     *     params:{
     *         title: 弹框标题，
     *         msg: 弹窗内容
     *         cancel: 取消文本
     *         confirm: 确认文本
     *     }
     *     callback({
     *         buttonIndex: 1表示确认，0表示取消
     *     })
     */
    var dialogBox = api.require('dialogBox');
    dialogBox.alert({
        texts: {
            title: params.title || '提示',
            content: params.msg || '',
            leftBtnTitle: params.cancel || '取消',
            rightBtnTitle: params.confirm || '确定'
        },
        styles: {
            bg: '#fff',
            corner: 5,
            w: 300,
            title: {
                marginT: 20,
                // icon: 'widget://res/gou.png',
                iconSize: 40,
                titleSize: 18,
                titleColor: '#000'
            },
            content: {
                color: '#000',
                size: 16
            },
            left: {
                marginB: 10,
                marginL: 20,
                w: 130,
                h: 36,
                bg: '#eee',
                size: 14,
                corner: 18,
                color: '#121212'
            },
            right: {
              marginB: 10,
              marginL: 10,
              w: 130,
              h: 36,
              corner: 18,
              bg: '#6c3bf5',
              size: 14,
              color: '#fff'
            }
        }
    }, function(ret) {
        // alert(JSON.stringify(ret));
        setTimeout(function(){
            var dialogBox = api.require('dialogBox');
            dialogBox.close({
                dialogName: 'alert'
            });
        },200)
        callback({
            buttonIndex: ret.eventType == 'right'?1:0
        })
    });
}
/*打开沃慧窗口*/
function openWTWin(name,data){
    if(!getValue("refresh_token")){
        console.log(getValue("refresh_token"))
        openWin("login_win")
        return
    }
    if(!$api.getStorage("user").openid){
        console.log(1)
        openWin("bindAccount")
        return
    }
    var delay = 0;
    if(api.systemType != 'ios'){
        delay = 300;
    }
    console.log(JSON.stringify(data))
    api.openWin({
        name: ''+name,
        url: api.wgtRootDir+'/html/'+name+'.html',
        bounces:false,
        delay: delay,
        reload: true,
        pageParam:data,
        slidBackEnabled:true,
        vScrollBarEnabled:false
    });
}
var Validator=function(){
  this.cache=[]
}
Validator.prototype.add=function(value,rule,msgValue){
  var arg=rule.split(":")
  this.cache.push(function(){
    var func=arg.shift();
    arg.unshift(value);
    arg.push(msgValue)
    return strategys[strategy].apply(null,str);
  })
}

Validator.prototype.start = function(){
    for(var i = 0, validatorFunc; validatorFunc = this.cache[i++]; ) {
        var msg = validatorFunc(); // 开始效验 并取得效验后的返回信息
        if(msg) {
            return msg;
        }
    }
};
var validateFunc = function(){
    var validator = new Validator(); // 创建一个Validator对象
    /* 添加一些效验规则 */
    validator.add(registerForm.userName,'isNotEmpty','用户名不能为空');
    validator.add(registerForm.password,'minLength:6','密码长度不能小于6位');
    validator.add(registerForm.userName,'mobileFormat','手机号码格式不正确');

    var errorMsg = validator.start(); // 获得效验结果
    return errorMsg; // 返回效验结果
};


/*打开新的窗口*/
// function openWin(name,data){
//     var delay = 0;
//     if(api.systemType != 'ios'){
//         delay = 300;
//     }
//
//     api.openWin({
//         name: ''+name,
//         url: ''+name+'.html',
//         bounces:false,
//         delay: delay,
//         reload: true,
//         pageParam:data,
//         slidBackEnabled:true,
//         vScrollBarEnabled:false
//     });
// }
/*关闭窗口*/
function closeWin(name){
  var params = {}
  if(name){
    params.name = name;
  }
  api.closeWin(params);
}
/* 时间格式化 */
Date.prototype.Format = function (fmt) {
    var o = {
        "M+": this.getMonth() + 1, /*月份*/
        "d+": this.getDate(), /*日*/
        "h+": this.getHours(), /*小时*/
        "m+": this.getMinutes(), /*分*/
        "s+": this.getSeconds(), /*秒*/
        "q+": Math.floor((this.getMonth() + 3) / 3), /*季度*/
        "S": this.getMilliseconds() /*毫秒*/
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
};
